VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMath"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' // ===============================================================
'      ,     _
      .   ,  _
              .
' // ===============================================================

Private m_lInchDrobArray(2) As Long
Private m_sLeft As String
Private m_sRight As String

Public Enum MATCH_ACTION
  MA_PLUS = 1
  MA_MINUS = 2
End Enum

Private Type DROB_ELEMENT
  deCurrency As Long
  deDx As Long
  deNx As Long
End Type
Public Function InchAction(sLeft As String, sRight As String, _
maAction As MATCH_ACTION, Optional bIsMake16 As Boolean = False) As String
'    
Dim deLeft As DROB_ELEMENT, deRight As DROB_ELEMENT
Dim deResult As DROB_ELEMENT, snDiff As Single
Dim j As Integer, i As Integer

On Error GoTo eRes

If Trim(sLeft) = "0" Then
  InchAction = sRight
  Exit Function
End If

If Trim(sRight) = "0" Then
  InchAction = sLeft
  Exit Function
End If

deLeft = SplitInchDrob(sLeft)
deRight = SplitInchDrob(sRight)
'    "" .
If deLeft.deCurrency <> 0 And (deLeft.deDx <> 0 Or deLeft.deNx <> 0) Then
  deLeft.deNx = deLeft.deCurrency * deLeft.deDx + deLeft.deNx
  deLeft.deCurrency = 0
ElseIf deLeft.deCurrency <> 0 Then
  deLeft.deNx = deLeft.deCurrency
  deLeft.deDx = 1
  deLeft.deCurrency = 0
End If
If deRight.deCurrency <> 0 And (deRight.deDx <> 0 Or deRight.deNx <> 0) Then
  deRight.deNx = deRight.deCurrency * deRight.deDx + deRight.deNx
  deRight.deCurrency = 0
ElseIf deRight.deCurrency <> 0 Then
  deRight.deNx = deRight.deCurrency
  deRight.deDx = 1
  deRight.deCurrency = 0
End If

Select Case maAction
  Case MA_PLUS
    '  
    If deLeft.deDx = deRight.deDx Then
      deResult.deNx = deLeft.deNx + deRight.deNx
      deResult.deDx = deLeft.deDx
    Else
      deResult.deNx = (deLeft.deNx * deRight.deDx) + (deLeft.deDx * deRight.deNx)
      deResult.deDx = deLeft.deDx * deRight.deDx
    End If
  Case MA_MINUS
    '  
    If (deLeft.deNx * deRight.deDx) <= (deLeft.deDx * deRight.deNx) Then
      deResult.deCurrency = 0
      deResult.deNx = 0
      deResult.deDx = 0
    Else
      deResult.deNx = (deLeft.deNx * deRight.deDx) - (deLeft.deDx * deRight.deNx)
      deResult.deDx = deLeft.deDx * deRight.deDx
    End If
End Select

With deResult
  If .deNx >= .deDx And .deDx <> 0 Then
    '     ""
    .deCurrency = Int(.deNx / .deDx)
    .deNx = .deNx - .deCurrency * .deDx
  End If
  If .deDx <> 0 And .deNx <> 0 Then
    '   
    If Int(.deDx / .deNx) = .deDx / .deNx Then
      .deDx = .deDx / .deNx
      .deNx = 1
    End If
  End If
  '    16 (     )
  If .deDx > 16 And bIsMake16 Then
    snDiff = .deDx / 16
    .deNx = Int(.deNx / snDiff)
    .deDx = 16
  End If
  
  '   (  ).
  If .deDx <> 0 Then
    For i = 1 To 2
      For j = 1 To .deDx
        If .deDx / j = Int(.deDx / j) And .deNx / j = Int(.deNx / j) Then
          .deDx = .deDx / j
          .deNx = .deNx / j
        End If
      Next
    Next
  End If
End With

  If deResult.deCurrency <> 0 Then
    If deResult.deNx = 0 Or deResult.deDx = 0 Then
      InchAction = deResult.deCurrency
    Else
      InchAction = deResult.deCurrency & " " & deResult.deNx & "/" & deResult.deDx
    End If
  ElseIf deResult.deNx = 0 Or deResult.deDx = 0 Then
    InchAction = 0
  Else
    InchAction = deResult.deNx & "/" & deResult.deDx
  End If

Exit Function
eRes:
  Call Err.Raise(vbObjectError + 513, "InchAction ", _
  "Error of internal function [" & Err.Description & "]")
  InchAction = "ERROR!"
'  Resume Next
End Function

Private Function IsCompareDrob(sItem As String) As Boolean
'     ....

'IsCompareDrob = True

If UBound(Split(TrimSpaces(sItem), " ")) > 1 Then
  IsCompareDrob = False
Else
  IsCompareDrob = True
End If

Exit Function
eRes:
  Call Err.Raise(vbObjectError + 513, "IsCompareDrob ", _
  "Error of internal function [" & Err.Description & "]")
  IsCompareDrob = False
  'Resume Next
End Function

Public Function MakeDrobShort(sDrb As String) As String
'  
Dim deCDrob As DROB_ELEMENT, i As Integer, j As Integer

On Error GoTo eRes

sDrb = TrimSpaces(sDrb)
deCDrob = SplitInchDrob(sDrb)

With deCDrob
  If .deDx <> 0 Then
    For i = 1 To 3
      For j = 1 To .deDx
        If .deDx / j = Int(.deDx / j) And .deNx / j = Int(.deNx / j) Then
          .deDx = .deDx / j
          .deNx = .deNx / j
        End If
      Next
    Next
  End If

  If .deCurrency <> 0 Then
    If .deNx = 0 Or .deDx = 0 Then
      MakeDrobShort = .deCurrency
    Else
      MakeDrobShort = .deCurrency & " " & .deNx & "/" & .deDx
    End If
  ElseIf .deNx = 0 Or .deDx = 0 Then
    MakeDrobShort = 0
  Else
    MakeDrobShort = .deNx & "/" & .deDx
  End If

End With

Exit Function
eRes:
  Call Err.Raise(vbObjectError + 513, "MakeDrobShort", _
  "Error of internal function [" & Err.Description & "]")
  Resume Next
End Function

Private Function SplitInchDrob(ByVal sInchDrob As String) As DROB_ELEMENT
'
Dim sTmpArray() As String, sTmpString As String
Dim j As Integer, lStart As Long

On Error GoTo eRes

sInchDrob = TrimSpaces(Trim(sInchDrob))
sTmpArray = Split(Trim(sInchDrob), " ")

If InStr(1, Trim(sTmpArray(0)), "/") <> 0 Then
  SplitInchDrob.deCurrency = 0
  lStart = 0
Else
  SplitInchDrob.deCurrency = CLng(Trim(sTmpArray(0)))
  lStart = 1
End If

' "" 
sTmpString = ""
For j = lStart To UBound(sTmpArray)
  If Trim(sTmpArray(j)) <> "" Then sTmpString = sTmpString & Trim(sTmpArray(j))
Next

If InStr(1, sTmpString, "/") = 0 Then Exit Function

Erase sTmpArray
sTmpArray = Split(sTmpString, "/")
SplitInchDrob.deNx = CLng(sTmpArray(0))
SplitInchDrob.deDx = CLng(sTmpArray(1))

Exit Function
eRes:
  Call Err.Raise(vbObjectError + 513, "SplitInchDrob ", _
  "Error of internal function [" & Err.Description & "]")
  Resume Next
End Function


Private Function TrimSpaces(ByVal sItem As String) As String
'   
Dim j As Long

On Error GoTo eRes

For j = 1 To Int(Len(sItem) / 2)
  sItem = Replace(sItem, "  ", " ")
Next

For j = 1 To Int(Len(sItem) / 2)
  sItem = Replace(sItem, " /", "/")
  sItem = Replace(sItem, "/ ", "/")
Next

TrimSpaces = sItem

Exit Function
eRes:
  Call Err.Raise(vbObjectError + 513, "TrimSpaces", _
  "Error of internal function [" & Err.Description & "]")
  Resume Next
End Function


